{*************
 *
 * Copyright  1997 CEO Systems Inc.
 *
 * Project....: VCL
 * File.......: StrList.pas
 * Author.....: Alexander V. Losev
 * Date.......: 30 July 1997
 * Description: Enhanced TStringList
 *
 *************}

unit StrList;

interface

uses
  Classes;

type

  {Class TStringListPro}
  TStringListPro = class (TStringList)
  private
    function  GetItem (Num: Integer): String;
    procedure SetItem (Num: Integer; Value: String);

  public
    property  Strings[Index: Integer]: String read GetItem write SetItem; default;
    function  Find (const S: String; var Index: Integer): Boolean;
    function  UpperFind (const S: String; var Index: Integer): Boolean;
    procedure Pack;
    procedure Assign(Value: TStringList);
  end;

implementation

uses
  SysUtils;

//--------------------------------------------------------------------//
//                            TStringListPro                          //
//--------------------------------------------------------------------//

{*************
* Name.......: GetItem
*}
function  TStringListPro.GetItem (Num: Integer): String;
begin
  if ( Count - 1 >= Num ) then
    Result := inherited Strings[Num]
  else
    Result := '';
end;


{*************
* Name.......: SetItem
*}
procedure TStringListPro.SetItem (Num: Integer; Value: String);
var
  I: Integer;

begin
  if ( Count - 1 < Num ) then
    for I := Count to Num do Add ('');

  Delete(Num);
  Insert(Num, Value);
end;


{*************
* Name.......: Pack
*}
procedure TStringListPro.Pack;
var
  I: Integer;

begin
  I := 0;
  while ( I < Count ) do
  if ( Strings[I] <> '' ) then
    Inc(I)
  else
    Delete(I);
end;


{*************
* Name.......: Find
*}
function  TStringListPro.Find (const S: String; var Index: Integer): Boolean;
var
  I, J: Integer;

begin
  Index := -1;
  J     := Count - 1;
  Result := False;
  for I := 0 to J do
  if ( Strings[I] = S ) then
  begin
    Result := True;
    Index  := I;
    Break;
  end;
end;


{*************
* Name.......: UpperFind
*}
function  TStringListPro.UpperFind (const S: String; var Index: Integer): Boolean;
var
  I, J: Integer;
  TmpStr: String;

begin
  Index := -1;
  J := Count - 1;
  Result := False;
  TmpStr := UpperCase(S);
  for I := 0 to J do
  if ( UpperCase(Strings[I]) = TmpStr ) then
  begin
    Result := True;
    Index  := I;
    Break;
  end;
end;










procedure TStringListPro.Assign(Value: TStringList);
var
  I, J: Integer;

begin
  J := Value.Count - 1;
  Clear;
  for I := 0 to J do Add(Value.Strings[I]);
end;

end.
