{*************
 *              
 * Copyright  1997 CEO Systems Inc.
 *
 * Project....: VCL
 * File.......: TaskBar.pas
 * Author.....: Alexander V. Losev
 * Date.......: 03 September 1997
 * Description: Work with TaskBar
 *
 *************}

unit TaskBar;

interface

uses
  Windows, Messages, ShellAPI, Classes;

const
  UM_ACTIVATEICON = $125;

// Rewrite on delhy from windows help.
function MyTaskBarAddIcon(TheHandle: HWND;
  uID: UINT; Thehicon: HICON; lpszTip: LPSTR): Boolean;
function MyTaskBarDeleteIcon(TheHandle: HWND; uID: UINT): Boolean;

// Custom writed by me.
function MyTaskBarAddButton(TheHandle: HWND): UINT;
function MyTaskBarDeleteButton(TheHandle: HWND): UINT;

implementation

function MyTaskBarAddIcon(TheHandle: HWND; uID: UINT;
  TheHIcon: HICON; lpszTip: LPSTR): Boolean;
var
  tnid: TNotifyIconData;

begin
  tnid.cbSize := SizeOf (TNotifyIconData);
  tnid.Wnd    := TheHandle;
  tnid.uID    := uID;
  tnid.uFlags := NIF_ICON	or NIF_MESSAGE or NIF_TIP;
  tnid.uCallbackMessage := SC_DEFAULT;//UM_ACTIVATEICON; ??
  tnid.hIcon  := Thehicon;
  if ( lpszTip <> '' ) then
    lstrcpyn(tnid.szTip, lpszTip, SizeOf(tnid.szTip))
  else
    tnid.szTip[0] := #0;

  Result := ShellApi.Shell_NotifyIcon (NIM_ADD, @tnid);

 // if ( TheHIcon <> 0 ) then     // not clear code from author
 //   DestroyIcon (TheHIcon);
end;


// MyTaskBarDeleteIcon - deletes an icon from the taskbar
//     notification area.
// Returns TRUE if successful or FALSE otherwise.
// hwnd - handle of the window that added the icon
// uID - identifier of the icon to delete

function MyTaskBarDeleteIcon(TheHandle: HWND; uID: UINT): Boolean;
var
  tnid: TNotifyIconData;

begin
	tnid.cbSize := sizeof(TNotifyIconData);
	tnid.Wnd    := TheHandle;
	tnid.uID    := uID;
	Result      := ShellApi.Shell_NotifyIcon(NIM_DELETE, @tnid);
end;

function MyTaskBarAddButton(TheHandle: HWND): UINT;
var
  Info:  TAppBarData;
  MesId: DWORD;

begin
  Info.cbSize           := SizeOf(TAppBarData);
  Info.hWnd             := TheHandle;
  Info.uCallbackMessage := UM_ACTIVATEICON;
  MesID                 := ABM_NEW;
  Result                := ShellApi.SHAppBarMessage(MesID, Info);
  MesID                 := ABM_SETPOS;
  Info.uEdge            := ABE_LEFT;
  Info.rc               := Classes.Rect(50, 50, 100, 100);
  ShellApi.SHAppBarMessage(MesID, Info);
end;


function MyTaskBarDeleteButton(TheHandle: HWND): UINT;
var
  Info: TAppBarData;
  MesId: DWORD;

begin
  Info.cbSize           := SizeOf(TAppBarData);
  Info.hWnd             := TheHandle;
  MesID                 := ABM_REMOVE;
  Result                := ShellApi.SHAppBarMessage(MesID, Info);
end;

end.
